Attribute VB_Name = "Global"
Option Explicit
'   Este archivo es parte del programa "reseter", el cal es pertenece a SVCommunity.org y a Todosv.com
'   Mantenedores principales:
'    *Vladimir
    
Public Declare Function ShowWindow& _
               Lib "user32" (ByVal hwnd As Long, _
                             ByVal nCmdShow As Long)
' Opciones
Public Declare Function GetPrivateProfileString _
               Lib "kernel32" _
               Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
                                                 ByVal lpKeyName As Any, _
                                                 ByVal lpDefault As String, _
                                                 ByVal lpReturnedString As String, _
                                                 ByVal nSize As Long, _
                                                 ByVal lpFileName As String) As Long
Public Declare Function WritePrivateProfileString _
               Lib "kernel32" _
               Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
                                                   ByVal lpKeyName As Any, _
                                                   ByVal lpString As Any, _
                                                   ByVal lpFileName As String) As Long

' http://support.microsoft.com/?scid=kb%3Ben-us%3B231298&x=6&y=17
Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

'Private Const WAIT_ABANDONED& = &H80&
'Private Const WAIT_ABANDONED_0& = &H80&
'Private Const WAIT_FAILED& = -1&
'Private Const WAIT_IO_COMPLETION& = &HC0&
Private Const WAIT_OBJECT_0& = 0
'Private Const WAIT_OBJECT_1& = 1
'Private Const WAIT_TIMEOUT& = &H102&

Private Const INFINITE = &HFFFF
Private Const ERROR_ALREADY_EXISTS = 183&

Private Const QS_HOTKEY& = &H80
Private Const QS_KEY& = &H1
Private Const QS_MOUSEBUTTON& = &H4
Private Const QS_MOUSEMOVE& = &H2
Private Const QS_PAINT& = &H20
Private Const QS_POSTMESSAGE& = &H8
Private Const QS_SENDMESSAGE& = &H40
Private Const QS_TIMER& = &H10
Private Const QS_MOUSE& = (QS_MOUSEMOVE Or QS_MOUSEBUTTON)
Private Const QS_INPUT& = (QS_MOUSE Or QS_KEY)
'Private Const QS_ALLEVENTS& = (QS_INPUT _
 Or QS_POSTMESSAGE _
 Or QS_TIMER _
 Or QS_PAINT _
 Or QS_HOTKEY)
Private Const QS_ALLINPUT& = (QS_SENDMESSAGE Or QS_PAINT Or QS_TIMER Or QS_POSTMESSAGE _
        Or QS_MOUSEBUTTON Or QS_MOUSEMOVE Or QS_HOTKEY Or QS_KEY)

Private Declare Function CreateWaitableTimer _
                Lib "kernel32" _
                Alias "CreateWaitableTimerA" (ByVal lpSemaphoreAttributes As Long, _
                                              ByVal bManualReset As Long, _
                                              ByVal lpName As String) As Long
    
'Private Declare Function OpenWaitableTimer Lib "kernel32" Alias "OpenWaitableTimerA" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal lpName As String) As Long
    
Private Declare Function SetWaitableTimer _
                Lib "kernel32" (ByVal hTimer As Long, _
                                lpDueTime As FILETIME, _
                                ByVal lPeriod As Long, _
                                ByVal pfnCompletionRoutine As Long, _
                                ByVal lpArgToCompletionRoutine As Long, _
                                ByVal fResume As Long) As Long
    
'Private Declare Function CancelWaitableTimer Lib "kernel32" (ByVal hTimer As Long)
    
Private Declare Function CloseHandle _
                Lib "kernel32" (ByVal hObject As Long) As Long
    
'Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
    
Private Declare Function MsgWaitForMultipleObjects _
                Lib "user32" (ByVal nCount As Long, _
                              pHandles As Long, _
                              ByVal fWaitAll As Long, _
                              ByVal dwMilliseconds As Long, _
                              ByVal dwWakeMask As Long) As Long

'Creamos los controladores de las clases y exponemos sus propiedades
Public r_2Wire As New m2Wire
Public r_Xavi As New mXavi4110a
Public r_Zyxel As New mZyxel_Prestige

'Tipo
Type rt_Datos
    direccion As String
    base As String
    accion As String
    Usuario As String
    clave As String
    Puerto As Long
    nForm As Integer
    nCont As Integer
End Type

Public m_Datos As rt_Datos
Public IE As Object

Public Sub Crear_Conexion()
    Set IE = CreateObject("InternetExplorer.Application")
End Sub

Public Sub Destruir_Conexion()
    Set IE = Nothing
    End
End Sub

Public Sub Esperar(lNumberOfSeconds As Single)
        Dim ft As FILETIME
        Dim lBusy As Long
        Dim lRet As Long
        Dim dblDelay As Double
        Dim dblDelayLow As Double
        Dim dblUnits As Double
        Dim hTimer As Long
    
100     hTimer = CreateWaitableTimer(0, True, App.EXEName & "Timer")
    
102     If Err.LastDllError = ERROR_ALREADY_EXISTS Then
            ' If the timer already exists, it does not hurt to open it
            ' as long as the person who is trying to open it has the
            ' proper access rights.
        Else
104         ft.dwLowDateTime = -1
106         ft.dwHighDateTime = -1
108         lRet = SetWaitableTimer(hTimer, ft, 0, 0, 0, 0)
        End If
    
        ' Convert the Units to nanoseconds.
110     dblUnits = CDbl(&H10000) * CDbl(&H10000)
112     dblDelay = CDbl(lNumberOfSeconds) * 1000 * 10000
    
        ' By setting the high/low time to a negative number, it tells
        ' the Wait (in SetWaitableTimer) to use an offset time as
        ' opposed to a hardcoded time. If it were positive, it would
        ' try to convert the value to GMT.
114     ft.dwHighDateTime = -CLng(dblDelay / dblUnits) - 1
116     dblDelayLow = -dblUnits * (dblDelay / dblUnits - Fix(dblDelay / dblUnits))
    
118     If dblDelayLow < CDbl(&H80000000) Then
            ' &H80000000 is MAX_LONG, so you are just making sure
            ' that you don't overflow when you try to stick it into
            ' the FILETIME structure.
120         dblDelayLow = dblUnits + dblDelayLow
122         ft.dwHighDateTime = ft.dwHighDateTime + 1
        End If
    
124     ft.dwLowDateTime = CLng(dblDelayLow)
126     lRet = SetWaitableTimer(hTimer, ft, 0, 0, 0, False)
    
        Do
            ' QS_ALLINPUT means that MsgWaitForMultipleObjects will
            ' return every time the thread in which it is running gets
            ' a message. If you wanted to handle messages in here you could,
            ' but by calling Doevents you are letting DefWindowProc
            ' do its normal windows message handling---Like DDE, etc.
128         lBusy = MsgWaitForMultipleObjects(1, hTimer, False, INFINITE, QS_ALLINPUT&)

130         DoEvents
132     Loop Until lBusy = WAIT_OBJECT_0
    
        ' Close the handles when you are done with them.
134     CloseHandle hTimer

End Sub
